<script setup lang="ts">
import { useNewsStore } from "@/stores";
import { computed, onMounted, ref } from "vue";
import type { NewsOut } from "@/client/types.gen.ts";
import NewsRenderer from "@/components/news/NewsRenderer.vue";

const props = defineProps<{
  newsId: string;
}>();

const loading = ref<boolean>(true);

const newsRepository = useNewsStore();
const newsEvent = computed<NewsOut | undefined>(
  () => newsRepository.newsMapping[props.newsId],
);

onMounted(() => {
  newsRepository.fetchNewsById(props.newsId).finally(() => {
    loading.value = false;
  });
});
</script>

<template>
  <div v-if="loading" class="d-flex justify-content-center">
    <div class="spinner-border" style="width: 3rem; height: 3rem" role="status">
      <span class="visually-hidden">Loading...</span>
    </div>
  </div>
  <div v-else-if="newsEvent == undefined" class="text-center mt-2 fs-3">
    Can't find news event by id {{ newsId }}<br />
    <router-link :to="{ name: 'dashboard' }">Back</router-link>
  </div>
  <news-renderer v-else :news-event="newsEvent" />
</template>

<style scoped></style>
